﻿Public Class frm_Main

    Structure ReicheltKomponente
        Dim Artikelname As String
        Dim ArtikelAnzahl As UInt32
    End Structure

    Private Sub btn_OpenFile_DragDrop(sender As Object, e As DragEventArgs) Handles btn_OpenFile.DragDrop
        Try
            If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                ' Liste der Filenamen bei Multi-Drop
                Dim FileList() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
                If FileList IsNot Nothing AndAlso FileList.Length > 0 Then
                    ProcessFiles(FileList)
                End If
            End If
        Catch ex As Exception
            MsgBox("Unexpected exception while Drop:" & vbLf & ex.Message)
        End Try
        e.Effect = DragDropEffects.None
    End Sub

    Private Sub btn_OpenFile_Click(sender As Object, e As EventArgs) Handles btn_OpenFile.Click
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.ShowDialog()
        If (OpenFileDialog1.FileName <> "") Then
            ProcessFiles(OpenFileDialog1.FileNames)
        End If
    End Sub

    Private Sub btn_OpenFile_DragEnter(sender As Object, e As DragEventArgs) Handles btn_OpenFile.DragEnter
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Sub ProcessFiles(ByVal Filenames() As String)
        Me.Visible = False
        Try
            Dim BigReicheltList As New List(Of ReicheltKomponente)

            For FileCount = 0 To Filenames.Count - 1
                Dim File() As String = My.Computer.FileSystem.ReadAllText(Filenames(FileCount)).Split(vbLf)
                Dim Filename As String = IO.Path.GetFileName(Filenames(FileCount))
                If IsNothing(File) Then
                    MsgBox("Leere Datei (Nothing): " & Filenames(FileCount))
                    GoTo EndOfProcess
                End If
                If File.Count < 1 Then
                    MsgBox("Leere Datei (Kein Inhalt): " & Filenames(FileCount))
                    GoTo EndOfProcess
                End If

                Dim ib As String = InputBox("Multiplikator für Liste eingeben für Datei: " & Filename, "Reichelt Multiplier", "10")
                If ((ib = "") Or (Not IsNumeric(ib))) Then
                    MsgBox("Ungültiger Multiplikator")
                    GoTo EndOfProcess
                End If
                Dim Multiplikator As UInt32 = CInt(ib)

                If File(UBound(File)) = "" Then 'Clear clear items -> Beacuse splitting with "vbLf"
                    ReDim Preserve File(UBound(File) - 1)
                End If

                For i As UInt32 = 0 To File.Count - 1
                    Dim Entry() As String = File(i).Split(";")
                    If Entry.Count = 0 Then
                        MsgBox("Fehler beim splitten in Zeile: " & File(i) & " in Datei: " & Filename)
                        GoTo EndOfProcess
                    End If
                    If ((Entry(0) = "") Or (Entry(1) = "")) Then
                        MsgBox("Fehler in Datei. Leeres Feld. Zeile: " & i + 1 & " in Datei: " & Filename)
                        GoTo EndOfProcess
                    End If

                    If Not IsNumeric(Entry(1).Replace(Chr(34), "")) Then
                        MsgBox("Fehler in Datei. Ungültige Stückzahl. Zeile: " & i + 1 & " in Datei: " & Filename)
                        GoTo EndOfProcess
                    End If

                    Dim RK As New ReicheltKomponente
                    RK.Artikelname = Entry(0)
                    RK.ArtikelAnzahl = CInt(Entry(1).Replace(Chr(34), ""))
                    RK.ArtikelAnzahl = RK.ArtikelAnzahl * Multiplikator
                    BigReicheltList.Add(RK)
                Next i
            Next FileCount

            If BigReicheltList.Count <= 0 Then
                MsgBox("Fehler in BigReicheltList. Keine Items eingetragen.")
                GoTo EndOfProcess
            End If

            Dim NewFile As String = ""
            For i = 0 To BigReicheltList.Count - 1
                NewFile = NewFile & BigReicheltList(i).Artikelname & ";" & BigReicheltList(i).ArtikelAnzahl & vbLf
            Next i

            SaveFileDialog1.FileName = ""
            SaveFileDialog1.ShowDialog()
            If SaveFileDialog1.FileName <> "" Then
                My.Computer.FileSystem.WriteAllText(SaveFileDialog1.FileName, NewFile, False)
                If MsgBox("Erfolgreich gespeichert." & vbLf & "Datei öffnen?", vbYesNo) = vbYes Then
                    Shell("explorer " & SaveFileDialog1.FileName)
                End If
            End If

        Catch ex As Exception
            MsgBox("Unexpected exception while Processfile:" & vbLf & ex.Message)
        End Try

EndOfProcess:
        Me.Visible = True
    End Sub

End Class
